
markup.push({


// MARK: custom menu item

// the one special menu item we add to our status item menu
GlobalMenuItem:
{
	nsClass: "GXMenuItem",
	//gxTitle: "Audio Hijack Sessions",
	gxMenuItemView:
	{
		nsClass: "GXMenuItemView",
		gxFrameRect: "0, 0, 410, 350",
		axTitle: "Audio Hijack Global Menu",
		axIsIgnored: true,
		gxViewModel: { nsClass: "AH4GlobalViewModel" },
		//gxBackPainter: fillPainter( colorMono(20, 60) ),
		gxBackPainter: fillPainter("BackColor1"),
		gxLayout: [
			"H:|-0-[self(410)]-0-|",
			"V:|-0-[self]-0-|",
			"V:|-45-[sessionsScrollView(300)]-0-[trialBar]-10-|",
			"H:|-0-[trialBar]-0-|",
				   
			"H:|-12-[detachBtn(22)]",
			"V:|-10-[detachBtn(22)]",
				   
			"H:|-82-[title]-82-|",
			"V:|-12-[title(18)]"
		],
		gxChildViews:
		{
			detachBtn: {
				"+": "RoundIconButton.popover.pin",
				gxToolTip: "Detach",
				axTitle: "Detach as Status Window"
			},
			title: {
				"+": "LabelView.mediumWeight.foreColor1.size14.noPressed",
				gxDefaultValue: "Audio Hijack Sessions",
				axIsIgnored: false,
				gxIntrinsicWidth: -1,
			},
			trialBar: "TrialBarView",
			sessionsScrollView:
			{
				nsClass: "GXScrollView",
				//gxBackColor: "BackColor1",
//				gxClipView: { nsClass: "GXClipView" },
				gxVScrollbar: "ScrollBarView",    // vertical scroller only
				gxLayout: "H:|[self]|",
				gxAddViewBelow: true,
				gxDocumentView:
				{
					nsClass: "GXListView",
					gxViewName: "sessionsList",
					gxLayout: "H:|-0-[self]-0-|",
					axIsIgnored: false,
					axTitle: "Sessions List",
					axHelp: "List of all sessions"
				}
			},
		},
	},
},


// MARK: popover

GlobalWindow:
{
	nsClass: "GXWindow",
	gxInitialWindowSize: "410, 500",     // for initial positioning
	gxBackColor: "BackColor1",
	gxWindowStyleMask: 0,
	gxContentView: "GlobalWindowContentView",
	gxFullSizeContentView: true,
},


GlobalWindowContentView:
{
	nsClass: "GXDrawView",
	gxBackPainter: "GroupViewBack",
	gxBackPainter:
	{
		nsClass: "GXPainter",
		gxCornerRadius: 4,
		gxFillColor: "BackColor1",
	},
	gxViewModel: { nsClass: "AH4GlobalViewModel" },
	gxLayout:
	[
		"H:[self(410)]",
	 
		"H:|-12-[pinBtn(20)]",
//		"H:|-12-[closeBtn(20)]-8-[pinBtn(20)]",
//		"V:|-10-[closeBtn(20)]",
		"V:|-10-[pinBtn(20)]",

		"V:|-45-[sessionsScrollView(300)]-0-[trialBar]-10-|",
		"H:|-0-[trialBar]-0-|",

		"H:|-82-[title]-82-|",
		"V:|-12-[title(16)]"
	],
	gxChildViews:
	{
		//closeBtn: { "+": "CloseButton" },
		pinBtn: { "+": "PinButton" },
		title: {
			"+": "LabelView.mediumWeight.foreColor1.size14.noPressed",
			gxDefaultValue: "Audio Hijack Sessions",
			axIsIgnored: false,
			gxIntrinsicWidth: -1,
		},
		trialBar: "TrialBarView",
		sessionsScrollView: {
			nsClass: "GXScrollView",
			gxBackColor: "BackColor1",
			gxVScrollbar: "ScrollBarView",	// vertical scroller only
			gxLayout: "H:|[self]|",
			gxAddViewBelow: true,
			gxDocumentView: {
				nsClass: "GXListView",
				gxViewName: "sessionsList",
				gxLayout: "H:|[self]|",
				axIsIgnored: true,
				//axTitle: "Sessions",
				//axHelp: "List of all sessions"
			}
		},
	}
},


// MARK: session list item

GlobalSessionListItem:
{
	nsClass: "GXListItem",
//	gxViewModel: {
//		nsClass: "AH4SessionViewModel",
//		gxSharedViewModelID: "SessionViewModel",
//	},
	gxSelectable: 2,
	gxDoubleClickKey: "sessionItemDoubleClick",
	gxIntrinsicWidth: 410,
	gxIntrinsicHeight: 38,
	//selectable: true,
	gxLayerZPosition: 10,
	axIsIgnored: false,
	axRoleDescription: "Session",
	axDescriptionKeyPath: "accessibilityDescription",
	gxBackPainter:
	{
		nsClass: "GXPainter",
		gxFillColor: "BackColor1.alpha30",
		selected: {
			gxFillColor: "SelectionColor3.alpha30",
			altRow: { }, // stop altRow resetting fill color
		},
		altRow: {
			gxFillColor: colorMono(50, 15),
		}
	},
	gxLayout: [
		"H:|-12-[title(120)]-5-[statusTime(80)]-6-[spinnerHost(18)]-6-[meterHostView(88)]-7-[runBtn(48)]",
		"V:|-9-[title]",
		"V:|-0-[statusTime(38)]",
		"V:|-10-[spinnerHost(18)]",
		"V:|-6-[meterHostView(26)]",
		"V:|-9-[runBtn(18)]",
	],
	gxChildViews:
	{
		title: {
			"+": "LabelView.size13.foreColor1.mediumWeight.left",
			gxValueKey: "name",
			axTitle: "Session Title",
			axIsIgnored: false,
		},
		statusTime: {
			"+": "LabelView.useMarkup.showAnimating.centery.right",
			gxAnimateOnKey: "graph.started",
			axTitle: "Status",
			axIsIgnored: false,
		},
		spinnerHost: {
			nsClass: "GXLayerHostingView",
			gxRootLayer:
			{
				nsClass: "GXCaarLayer",
				gxViewName: "spinner",
				gxAnimateOnKey: "running",
				gxHideOnNilValue: true,
				gxAnimationDivider: 2,
				gxCaarPainter: "RecordingSpinnerPainter",
			}
		},
		meterHostView:
		{
			nsClass: "GXLayerHostingView",
			gxLayerZPosition: 2,
			gxRootLayer:
			{
				nsClass: "AH4SpecMeterLayer",
				gxValueKey: "specMeterNarrowData",
				gxAnimateOnKey: "graph.started",
				gxForePainter: {
					nsClass: "GXPainter",
					gxFillColor: "ColorThemeLive2",
				},
			}
		},
		runBtn: {
			"+": "RunButton.size12",
		},
	}
},

	
})
