
markup.push({

// MARK: templates window

InspectorWindow:
{
	nsClass: "GXWindow",
	gxInitialWindowSize: "600, 610",	 // approx, for initial positioning
	gxInitialWindowPosition: "0.75, 0.5",
	gxWindowTitle: "Recording Inspector",
	gxSavedWindowStateKey: "inspectorWindow",
	gxBackColor: "BackColor1",
	gxFullSizeContentView: true,
	gxContentView: "InspectorWindowContentView",
},

// MARK: content view

InspectorWindowContentView:
{
	nsClass: "GXDrawView",
	gxViewModel: {
		nsClass: "AH4AudioFileViewModel",
		gxSharedViewModelID: "AudioFileViewModel"
	},
	gxLayout: [
		"V:|-(-1)-[barView(27)]-(-1)-[playerGroup]-(-1)-[infoGroup]-(-1)-[tagsGroup]-(-1)-[bottomBar]-(-1)-|", // sets window height
		"H:[self(>=540)]"		// sets window width
	],
	gxChildViews:
	{
		barView:	// 'titleBarView' is handled specialy, 'barView' isn't
		{
			"+": "TitleBarView",
			gxChildViews:
			{
				windowTitle: {
					"+": "WindowTitle",
					axIsIgnored: false,
					gxDefaultValue: "Recording Inspector"
					//axTitle: "Recording Inspector"
				},
			},
		},
		playerGroup:
		{
			"+": "PlayerView",
		},
		infoGroup:
		{
			"+": "InfoView",
		},
		tagsGroup:
		{
			"+": "TagsView",
		},
		bottomBar:
		{
			"+": "InspectorBottomBar",
		},
	}
},

// MARK: info view

InfoView:
{
	"+": "GroupView",
	axTitle: "Information",
	axIsIgnored: false,
	gxLayout:
	[
		"H:|-0-[self]-0-|",
		"V:|-14-[fileTimeLabel]-2-[fileTime]-14-|&alignLeft",
        "V:|-14-[fileSizeLabel]-2-[fileSize]-14-|&alignLeft",
        "V:|-14-[formatLabel]-2-[format]-14-|&alignLeft",
        "V:|-14-[dateLabel]-2-[shortDate]-14-|&alignLeft",
     
		"H:|-18-[fileTime(100)]-0-[sp1]-0-[fileSize(100)]-0-[sp2]-0-[format(150)]-0-[sp3]-0-[shortDate(150)]-16-|&alignBaseline",

        // equal size the spacers
        "H:[sp2(==sp1)]",
        "H:[sp3(==sp1)]",
	],
	gxChildViews:
	{
		fileTimeLabel: labelView("Duration:", "left"),
		fileTime: {
			"+": "LabelView.left.foreColor1.size13",
			gxValueKey: "fileTime",
			gxAnimateOnKey: "isRecording",
			gxFormatter: { nsClass: "PTTrackTimeFormatter" },
			axTitle: "Duration",
			axIsIgnored: false,
		},
		fileSizeLabel: labelView("Size:", "left"),
		fileSize: {
			"+": "LabelView.left.foreColor1.size13",
			gxValueKey: "fileSize",
			gxAnimateOnKey: "isRecording",
			gxFormatter: { nsClass: "PTFileSizeFormatter" },
			axTitle: "File Size",
			axIsIgnored: false,
		},
		formatLabel: labelView("Format:", "left"),
		format: {
			"+": "LabelView.left.foreColor1.size13",
			gxValueKey: "briefDescription",
			gxToolTipKeyPath: "fullDescription",
			axTitle: "File Format",
			axIsIgnored: false,
		},
		dateLabel: labelView("Recorded:", "left"),
		shortDate: {
			"+": "LabelView.foreColor1.left",
			axTitle: "Recorded Date",
			axIsIgnored: false,
		},
        // spacers
        sp1: spacerView(),
        sp2: spacerView(),
        sp3: spacerView(),
	}
},
	
// MARK: player view
	
PlayerView:
{
	"+": "GroupView",
	//axTitle: "Player",
	axIsIgnored: true,
	gxLayout:
	[
		"H:|-0-[self]-0-|",
		
		"H:|-13-[playBtn(34)]-3-[waveForm]-16-|&alignCenterY",

		"V:|-10-[waveForm(>=80)]-10-|",		// sets height
		"V:[playBtn(70)]",
	],
	gxChildViews:
	{
		emptyView: {
			nsClass: "GXDrawView",
			gxForePainter: "ImagePainter.top.foreColor3.empty-inspector",
			axIsIgnored: false,
			axDescription: "No Recording Selected",
			gxLayout: [
				"H:[superview]-(<=0)-[self(200)]&alignCenterY",
				"V:[superview]-(<=0)-[self(102)]&alignCenterX",
				// image is 84*78. text ~200 wide
				"H:|-0-[label]-0-|",
				"V:[label]-4-|",
			],
			gxChildViews: {
				label: labelView("No Recording Selected", "foreColor3.centerx.mediumWeight.size15"),
			},
		},
		recordingNowView: {
			nsClass: "GXDrawView",
			gxForePainter: "ImagePainter.top.colorLive1.empty-inspector",
			axIsIgnored: false,
			axDescription: "Recording in Progress",
			gxHideOnNilValue: true,
			gxLayout: [
				"H:[superview]-(<=0)-[self(200)]&alignCenterY",
				"V:[superview]-(<=0)-[self(102)]&alignCenterX",
				// image is 84*78. text ~200 wide
				"H:|-0-[label]-0-|",
				"V:[label]-4-|",
			],
			gxChildViews: {
				label: labelView("Recording in Progress", "colorLive1.centerx.mediumWeight.size15"),
			},
		},
		playBtn:
        {
			nsClass: "GXButtonView",
			gxBackPainter: "ImagePainter.foreColor1.playbtn.large",
			gxValueKey: "filePlayBtn",
			gxHideOnNilValue: true,
			gxLayerZPosition: 10,
            gxButtonType: "checkbox",
			axTitle: "play",
			axHelp: "play or pause this recording",
		},
        waveForm:
        {
            nsClass: "GXWaveView",
			gxValueKey: "playPosition",
			gxAnimateOnKey: "isPlaying",
			gxHideOnNilValue: true,
            gxLayout: [
                "H:|-0-[fullWave]-0-|",
                "V:|-0-[fullWave]-0-|",

                "H:[playhead(2)]",
                "V:|-0-[playhead]-0-|",
            ],
            gxRootLayer:
            {
                nsClass: "GXDrawLayer",
                gxLayerZPosition: 2,
                gxSublayers:
                {
                    fullWave: {
                        nsClass: "GXWaveLayer",
                        gxLayerZPosition: 4,
                        gxValueKey: "waveData",
                        gxNeedsDisplayOnResize: true,
                        gxPainter: {    // only provides colors
                            nsClass: "GXPainter",
                            gxBackColor: "BackColor2",
                            gxFillColor: "ForeColor1",
                        },
                    },
                    playhead: {
                        // playhead is a puppet created for GXWaveView to use
                        nsClass: "GXDrawLayer",
                        gxLayerZPosition: 10,
                        gxBackPainter: {    // only used for colors
                            nsClass: "GXPainter",
                            gxCornerRadius: 1,
                            gxBackColor: "ColorThemeLive1",
                        },
                    },
                }
            }
        },
	}
},
	
	
// MARK: tags view
	
TagsView:
{
	"+": "ExpandingGroupView",
	gxValueKey: "tagsExpanded",
	//gxDefaultValue: true,
	gxCollapsedSize: 35,
	gxExtraSize: 14,
	axTitle: "Tags",
	gxLayout:
	[
		"H:|-0-[self]-0-|",
	 	"V:|-0-[expandBtn]-2-[title]",
	 	
	 	"V:[expandBtn]-2-[artwork(160)]",
	 	"H:[artwork(160)]-16-|",
	 
		"H:[titleLabel]-8-[title]&alignBaseline",
		"H:[title]-10-[artwork]",
	 	
	 	"H:[artistLabel]-8-[artist]&alignBaseline",
		"H:[artist]-10-[artwork]",
	 
		"H:|-16-[albumLabel]-8-[album]&alignBaseline",
	 	"H:[album]-10-[artwork]",

		"V:[title]-9-[artist]-9-[album]&alignLeft",

		"H:[trackLabel]-8-[track(34)]-8-[trackCountLabel]-8-[trackCount(34)]&alignBaseline",
		"H:[yearLabel]-8-[year(44)]-13-[compilation(100)]&alignBaseline",
        "H:[compilation]-(>=10)-[artwork]",
     
		"V:[year]-9-[genre]&alignLeft",
	 
		"H:[discLabel]-8-[disc(34)]-8-[discCountLabel]-8-[discCount(34)]-8-[genreLabel]-8-[genre(157)]&alignBaseline",
		"H:[genre]-(>=10)-[artwork]",
	 
		"V:[album]-9-[track]-9-[disc]&alignLeft",

	 	"H:|-18-[comment]-16-|",
		"V:[disc]-10-[comment(96)]",
	],
	gxChildViews:
	{
		expandBtn:
		{
			"+": "AdvancedGroupButton",
			gxTitle: "<disclosure/> Tags",
			//gxDefaultValue: true,
			gxValueKey: "tagsExpanded",
			axFormatter: disclosureAxFormatter("Tags"),
			gxDisableOnNil: true,
		},
		titleLabel: labelView("Title:"),
		title: {
			"+": "DarkTextField",
			gxNilWhenEmpty: true,
			gxDisableOnNil: false,
			gxIsSingleLine: true,
			gxValueKey: "tags.title",
			axTitle: "Track Title",
			gxDisableOnKey: "disableEditing",
		},
		artistLabel: labelView("Artist:"),
		artist: {
			"+": "DarkTextField",
			gxNilWhenEmpty: true,
			gxDisableOnNil: false,
			gxValueKey: "tags.artist",
			axTitle: "Artist",
			gxDisableOnKey: "disableEditing",
		},
		albumLabel: labelView("Album:"),
		album: {
			"+": "DarkTextField",
			gxNilWhenEmpty: true,
			gxDisableOnNil: false,
			gxValueKey: "tags.album",
			axTitle: "Album",
			gxDisableOnKey: "disableEditing",
		},
		artwork: {
			"+": "ArtView",
			gxValueKey: "tags.albumArt",
			gxDisableOnKey: "disableEditing",
			axTitle: "Album Art",
		},
		yearLabel: labelView("Year:"),
		year: {
			"+": "DarkNumberField",
			gxRangeMax: 9999,
			gxValueKey: "tags.year",
			axTitle: "Year",
			gxDisableOnKey: "disableEditing",
		},
		trackLabel: labelView("Track:"),
		track: {
			"+": "DarkNumberField",
			gxValueKey: "tags.track",
			axTitle: "Track Number",
			gxDisableOnKey: "disableEditing",
		},
		trackCountLabel: labelView("of:"),
		trackCount: {
			"+": "DarkNumberField",
			gxValueKey: "tags.trackCount",
			axTitle: "Track Count",
			gxDisableOnKey: "disableEditing",
		},
		genreLabel: labelView("Genre:"),
		genre: {
			"+": "GenrePopupMenu",
			gxValueKey: "tags.genre",
			axTitle: "Genre",
			gxDisableOnKey: "disableEditing",
		},
		discLabel: labelView("Disc:"),
		disc: {
			"+": "DarkNumberField",
			gxValueKey: "tags.disc",
			axTitle: "Disc Number",
			gxDisableOnKey: "disableEditing",
		},
		discCountLabel: labelView("of:"),
		discCount: {
			"+": "DarkNumberField",
			gxValueKey: "tags.discCount",
			axTitle: "Disc Count",
			gxDisableOnKey: "disableEditing",
		},
		compilation: {
			"+": "CheckboxTemplate",
			gxValueKey: "tags.partOfCompilation",
			gxTitle: "<checkbox/> Compilation",
			gxDisableOnNil: false,
			gxDisableOnKey: "disableEditing",
		},
		comment: {
			"+": "DarkTextField",
			gxValueKey: "tags.comment",
			gxPlaceholderString: "Comments",
			axTitle: "Comments",
			gxDisableOnKey: "disableEditing",
		},
	}
},


// MARK: bottom bar

InspectorBottomBar:
{
	"+": "GroupView",
	axTitle: "Info Section",
	gxLayout:
	[
		"H:|-0-[self]-0-|",
		"V:|-14-[revealBtn]-14-|",

		"H:|-18-[revealBtn(80)]-9-[editorBtn(70)]-9-[musicBtn(80)]-9-[shareBtn(90)]-9-[deleteBtn(80)]&alignCenterY",
	 ],
	gxChildViews:
	{
		revealBtn: {
			"+": "ButtonView.useMarkup",
			gxTitle: "<icon.foreColor1.action.finder/> Reveal ",
            gxDisableOnKey: "disableEditing",
			axHelp: "Reveals this recording in the Finder",
		},
		editorBtn: {
			"+": "ButtonView.useMarkup",
			gxTitle: "<icon.foreColor1.action.edit/> Edit ",
            gxDisableOnKey: "disableEditing",
			axHelp: "Opens this recording in an Editor, set in Prefernces",
		},
        musicBtn: {
			"+": "ButtonView.useMarkup",
            gxDisableOnKey: "disableEditing",
			gxTitle: "<icon.foreColor1.action.music/> Music ",
			axHelp: "Adds this recording to Music.app",
		},
        shareBtn: {
            "+": "PopupMenuTemplate.useMarkup",
            gxTitle: "<icon.foreColor1.action.share/> Share",
            gxMenuItemsKeyPath: "model.shareMenuItems",
            gxHideOnNilValue: false,
			gxDisableOnKey: "disableEditing",
			axTitle: "Share"
        },
		deleteBtn: {
			"+": "ButtonView.useMarkup",
			gxTitle: "<icon.foreColor1.action.delete/> Delete ",
            gxDisableOnKey: "disableEditing",
			axHelp: "Removes this recording from Audio Hijack and optionally throws in the trash",
		},
	}
},

	
})
