
markup.push({

// MARK: - presets menu

// presets menu used in most block popovers
PresetsPopupMenu:
{
	"+": "PopupMenuView",
	nsClass: "GEPresetsPopupMenu",
	gxViewName: "presets",
	gxValueKey: "",	// so settings view treats popup as a valid control
	axTitle: "Presets",
    axHelp: "Create or use pre-sets for this block",
},

	
// MARK: presets window

PresetsWindow:
{
	nsClass: "GXWindow",
	gxWindowTitle: "Presets",
	gxWindowMaxSize: "320, 2000",
	gxWindowMinSize: "320, 230",
	gxInitialWindowSize: "320, 250",
	gxInitialWindowPosition: "0.3, 0.3",
	gxSavedWindowStateKey: "presetsWindow",
	gxBackColor: "BackColor2",
	gxContentView: "PresetsWindowContentView"
},

	
// MARK: content view

PresetsWindowContentView:
{
	nsClass: "GXDrawView",
	gxLayout:
	[
		"H:[self(320)]",
		
		"V:[titleBarView]-0-[titleGroup(38)]-0-[presetsScroller]-0-[bottomBar(36)]-0-|",
		
		"H:|-0-[titleGroup]-0-|",
		"H:|-0-[presetsScroller]-0-|",
		"H:|-0-[presetsList]-0-|",
	],
	gxViewModel:
	{
		nsClass: "GXListViewModel",
		gxSharedViewModelID: "PresetsList"
	},
	gxChildViews:
    {
		titleBarView:
		{
			"+": "TitleBarView",
			gxChildViews:
			{
				windowTitle: {
					"+": "WindowTitle",
					gxDefaultValue: "Presets",
				},
			},
		},
		titleGroup:
		{
			"+": "GroupView",
			gxLayout:
			[
				"H:|-15-[groupTitle]-0-|",
				"V:|-10-[groupTitle]",
			],
			gxChildViews:
			{
				groupTitle: {
					"+": "LabelView.useMarkup.left",
					gxValueKey: "displayName",
				},
			}
		},
		presetsScroller:
        {
			nsClass: "GXScrollView",
			gxBackColor: "SidebarBackColor2",
			gxVScrollbar: "ScrollBarView",	// vertical scroller only
			gxDocumentView:
            {
				gxViewName: "presetsList",
				nsClass: "GXStackView",
				gxTopHeight: 8,
				gxDefaultValue: true, // expanded!
				gxListItemView: "PresetItemView",
				gxListItemsKeyPath: "subModels",
				axTitle: "Presets List",
				axHelp: "Edit preset names or delete them from this list. Presets are used on individual Blocks within Sessions",
			}
		},
		bottomBar:
		{
			nsClass: "GXDrawView",
			gxBackPainter: "BottomBarBack",
			gxLayerZPosition: 1,
			gxLayout: [ "H:|-0-[self]-0-|",
					  	"H:[deleteBtn(24)]-14-|",
						"H:[self]-(<=0)-[deleteBtn]&alignCenterY" ],  // center vertically
			gxChildViews:
			{
				deleteBtn:
				{
					"+": "MinusButton",
					gxTitle: "<minusButton/>",
					gxValueKey: "deleteBtn",
					gxDisableOnNil: true,
					axDescription: "Delete selected sessions",
				}
			}
		}
	}
},

	
// MARK: preset item

PresetItemView:
{
	nsClass: "GXListItem",
	gxIntrinsicWidth: 300,
	gxIntrinsicHeight: 30,
	gxBackPainter: "PresetItemBg",
	gxSelectable: 2, // multiselect
	gxLateLayout: [
		"H:|-12-[presetName]-8-|",
		"V:|-4-[presetName]",
		
		"V:[self(33)]",	// needed!!
	],
	gxChildViews:
	{
		presetName:
		{
			"+": "BaseTextField",
			gxValueKey: "name",
			gxEditingKeyPath: "editing",
			gxTextPainter: { "+": "ControlFore", gxHAlign: 0, gxFontSize: 13 },
			gxEdgeInsets: "2, 4, 2, 3",
			//gxBackColor: "BackColor2",
			gxPencilForePainter: "PencilForePainter",
			gxPencilBackPainter: "PencilBackPainter",
			gxFocusRingPainter: "ControlBack",
			gxIntrinsicWidth: -1,
		}
	}
},

PresetItemBg:
{
	"+": "ListItemBack.altRow",
	gxCornerRadius: 8,
	gxEdgeInsets: "7, 1, 2, 1",
}

	
})
